

Imports LabDB.DBSaber.StdTools



Public Class Bacteria


#Region " Member Variables "

    Private m_BacteriaID As Integer
    Private m_LabName As String = ""
    Private m_RecDate As Date = Now
    Private m_FormerName As String = ""
    Private m_HostStrain As String = ""
    Private m_Markers As String = ""
    Private m_PlasmidSize As String = ""
    Private m_ParentVector As String
    Private m_Insert As String = ""
    Private m_Donor As String = ""
    Private m_Comments As String = ""
    Private m_LastModified As Date = Now


    Private m_CustomField1 As String = ""
    Private m_CustomField2 As String = ""


#End Region




    Public Const cTableName As String = "tblBacteria"





#Region " Construcors "

    Public Sub New()

        'Blank

    End Sub

    Public Sub New(ByRef rConn As Data.Common.DbConnection, ByVal vYeastID As Integer)

        Me.DBLoad(rConn, vYeastID)

    End Sub

    Public Sub New(ByRef rRS As Data.Common.DbDataReader)

        Me.RSLoad(rRS)

    End Sub

#End Region



#Region " Properties "

    Public Property BacteriaID() As Integer
        Get
            Return Me.m_BacteriaID
        End Get
        Set(ByVal value As Integer)
            Me.m_BacteriaID = value
        End Set
    End Property

    Public Property LabName() As String
        Get
            Return Me.m_LabName
        End Get
        Set(ByVal value As String)
            Me.m_LabName = value
        End Set
    End Property

    Public Property RecDate() As Date
        Get
            Return Me.m_RecDate
        End Get
        Set(ByVal value As Date)
            Me.m_RecDate = value
        End Set
    End Property

    Public Property FormerName() As String
        Get
            Return Me.m_FormerName
        End Get
        Set(ByVal value As String)
            Me.m_FormerName = value
        End Set
    End Property

    Public Property HostStrain() As String
        Get
            Return Me.m_HostStrain
        End Get
        Set(ByVal value As String)
            Me.m_HostStrain = value
        End Set
    End Property

    Public Property Markers() As String
        Get
            Return Me.m_Markers
        End Get
        Set(ByVal value As String)
            Me.m_Markers = value
        End Set
    End Property

    Public Property PlasmidSize() As String
        Get
            Return Me.m_PlasmidSize
        End Get
        Set(ByVal value As String)
            Me.m_PlasmidSize = value
        End Set
    End Property

    Public Property ParentVector() As String
        Get
            Return Me.m_ParentVector
        End Get
        Set(ByVal value As String)
            Me.m_ParentVector = value
        End Set
    End Property

    Public Property InsertOf() As String
        Get
            Return Me.m_Insert
        End Get
        Set(ByVal value As String)
            Me.m_Insert = value
        End Set
    End Property

    Public Property Donor() As String
        Get
            Return Me.m_Donor
        End Get
        Set(ByVal value As String)
            Me.m_Donor = value
        End Set
    End Property

    Public Property Comments() As String
        Get
            Return Me.m_Comments
        End Get
        Set(ByVal value As String)
            Me.m_Comments = value
        End Set
    End Property

    Public ReadOnly Property LastModified() As Date
        Get
            Return Me.m_LastModified
        End Get
    End Property

    Public ReadOnly Property FullName() As String
        Get
            Return Me.LabName & "-" & String.Format("{0:00000}", Me.BacteriaID)
        End Get
    End Property


    Public Property CustomField1() As String
        Get
            Return Me.m_CustomField1
        End Get
        Set(ByVal value As String)
            Me.m_CustomField1 = value
        End Set
    End Property

    Public Property CustomField2() As String
        Get
            Return Me.m_CustomField2
        End Get
        Set(ByVal value As String)
            Me.m_CustomField2 = value
        End Set
    End Property

#End Region


#Region " Database Support "


    Public Sub DBLoad(ByRef rConn As Data.Common.DbConnection, ByVal vBacteriaID As Integer)

        Dim RS As Data.Common.DbDataReader
        Dim Cmd As Data.Common.DbCommand = rConn.CreateCommand


        Cmd.CommandText = "SELECT * FROM " & cTableName & " WHERE BacteriaID=@pBacteriaID"
        CommandParamAdd(Cmd, "pBacteriaID", DbType.Int32, vBacteriaID)

        RS = Cmd.ExecuteReader


        If RS.HasRows = True Then
            RS.Read()
            Me.RSLoad(RS)
            RS.Close()
        Else
            'Couldn't find it in the table
            Throw New DBSaber.NoRecordFoundDBException(cTableName, "BacteriaID", vBacteriaID)
            RS.Close()
        End If


    End Sub

    Public Sub RSLoad(ByRef rRS As Data.Common.DbDataReader)

        Me.m_BacteriaID = rRS.GetInt32(0)
        Me.m_LabName = DBValStr(rRS, 1)
        Me.m_RecDate = DBValDate(rRS, 2)
        Me.FormerName = DBValStr(rRS, 3)
        Me.m_HostStrain = DBValStr(rRS, 4)
        Me.m_Markers = DBValStr(rRS, 5)
        Me.m_PlasmidSize = DBValStr(rRS, 6)

        Me.ParentVector = DBValStr(rRS, 7)
        Me.InsertOf = DBValStr(rRS, 8)
        Me.Donor = DBValStr(rRS, 9)
        Me.m_Comments = DBValStr(rRS, 10)
        Me.m_CustomField1 = DBValStr(rRS, 11)
        Me.m_CustomField2 = DBValStr(rRS, 12)
        Me.m_LastModified = DBValDate(rRS, 13)

    End Sub

    Public Sub DBSave(ByRef rConn As OleDb.OleDbConnection)


        Dim SQL As String
        'Dim DR As Data.Common.DbDataReader
        Dim Cmd As OleDb.OleDbCommand = rConn.CreateCommand


        If Me.BacteriaID = 0 Then

            Me.m_LastModified = Now


            'Insert

            SQL = "INSERT INTO " & cTableName & " (LabName, RecDate, FormerName, HostStrain, Markers, PlasmidSize, ParentVector, InsertOf, Donor, Comments, CustomField1, CustomField2, LastModified) VALUES ("
            SQL = SQL & "@pLabName, @pRecDate, @pFormerName, @pHostStrain, @pMarkers, @pPlasmidSize, @pParentVector, @pInsertOf, @pDonor, @pComments, @pCustomField1, @pCustomField2, @pLastModified)"


            'SQL = SQL & "; " & vbCrLf & " SELECT @@IDENTITY AS NewOligoID"


            Cmd.CommandText = SQL

            CommandParamAdd(Cmd, "pLabName", DbType.String, Me.LabName)
            CommandParamAdd(Cmd, "pRecDate", DbType.String, Me.RecDate)
            CommandParamAdd(Cmd, "pFormerName", DbType.String, Me.FormerName)
            CommandParamAdd(Cmd, "pHostStrain", DbType.String, Me.HostStrain)
            CommandParamAdd(Cmd, "pMarkers", DbType.String, Me.Markers)
            CommandParamAdd(Cmd, "pPlasmidSize", DbType.String, Me.PlasmidSize)
            CommandParamAdd(Cmd, "pParentVector", DbType.String, Me.ParentVector)
            CommandParamAdd(Cmd, "pInsertOf", DbType.String, Me.InsertOf)
            CommandParamAdd(Cmd, "pDonor", DbType.String, Me.Donor)
            CommandParamAdd(Cmd, "pComments", DbType.String, Me.Comments)
            CommandParamAdd(Cmd, "pCustomField1", DbType.String, Me.CustomField1)
            CommandParamAdd(Cmd, "pCustomField2", DbType.String, Me.CustomField2)
            CommandParamAdd(Cmd, "pLastModified", DbType.String, Me.m_LastModified)

            Cmd.ExecuteNonQuery()


            'retrieving the bacteriaid for the newly inserted record
            Me.BacteriaID = DBSaber.StdTools.DBValue(rConn, "SELECT BacteriaID FROM " & cTableName & " WHERE LastModified=@pLastModified", "@pLastModified", DbType.String, Me.LastModified)


        Else
            'Update

            Me.m_LastModified = Now

            SQL = "UPDATE " & cTableName & " SET LabName=@pLabName, RecDate=@pRecDate"
            SQL = SQL & ", FormerName=@pFormerName, HostStrain=@pHostStrain, Markers=@pMarkers, PlasmidSize=@pPlasmidSize, ParentVector=@pParentVector"
            SQL = SQL & ", InsertOf=@pInsertOf, Donor=@pDonor, Comments=@pComments"
            SQL = SQL & ", CustomField1=@pCustomField1, CustomField2=@pCustomField2, LastModified=@pLastModified"
            SQL = SQL & " WHERE BacteriaID=@pBacteriaID"


            Cmd.CommandText = SQL


            CommandParamAdd(Cmd, "pLabName", DbType.String, Me.LabName)
            CommandParamAdd(Cmd, "pRecDate", DbType.String, Me.RecDate)
            CommandParamAdd(Cmd, "pFormerName", DbType.String, Me.FormerName)
            CommandParamAdd(Cmd, "pHostStrain", DbType.String, Me.HostStrain)
            CommandParamAdd(Cmd, "pMarkers", DbType.String, Me.Markers)
            CommandParamAdd(Cmd, "pPlasmidSize", DbType.String, Me.PlasmidSize)
            CommandParamAdd(Cmd, "pParentVector", DbType.String, Me.ParentVector)
            CommandParamAdd(Cmd, "pInsertOf", DbType.String, Me.InsertOf)
            CommandParamAdd(Cmd, "pDonor", DbType.String, Me.Donor)
            CommandParamAdd(Cmd, "pComments", DbType.String, Me.Comments)
            CommandParamAdd(Cmd, "pCustomField1", DbType.String, Me.CustomField1)
            CommandParamAdd(Cmd, "pCustomField2", DbType.String, Me.CustomField2)
            CommandParamAdd(Cmd, "pLastModified", DbType.String, Me.m_LastModified)

            CommandParamAdd(Cmd, "pBacteriaID", DbType.String, Me.BacteriaID)


            Cmd.ExecuteNonQuery()



        End If


    End Sub


    Public Shared Function DBBacterias(ByRef rConn As Data.Common.DbConnection) As Generic.List(Of Bacteria)

        Dim Cmd As Data.Common.DbCommand = rConn.CreateCommand
        Dim RS As Data.Common.DbDataReader
        Dim tCollect As New Generic.List(Of Bacteria)

        Cmd.CommandText = "SELECT * FROM " & cTableName & " ORDER BY BacteriaID"


        RS = Cmd.ExecuteReader

        Do While RS.Read
            tCollect.Add(New Bacteria(RS))
        Loop

        RS.Close()


        Return tCollect


    End Function


    ''' <summary>
    ''' Returns a list of all the query items
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Shared Function DBQItems() As Generic.List(Of SQLQueryItem)

        Dim tCollect As New Generic.List(Of SQLQueryItem)

        tCollect.Add(New SQLQueryItem("Bacteria ID", "BacteriaID", DbType.Int32, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Lab Name", "LabName", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Record Date", "RecDate", DbType.Date, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Former Name", "FormerName", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Markers", "Markers", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Plasmid Size", "PlasmidSize", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Parent Vector", "ParentVector", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Insert", "InsertOf", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Donor", "Donor", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Comments", "Comments", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Custom Field 1", "CustomField1", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Custom Field 2", "CustomField2", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))


        Return tCollect


    End Function

    ''' <summary>
    ''' Removes a record from the database
    ''' </summary>
    ''' <param name="rConn"></param>
    ''' <param name="vYeastID"></param>
    ''' <remarks></remarks>
    Public Shared Sub DBDelete(ByRef rConn As Data.Common.DbConnection, ByVal vYeastID As Integer)

        Dim Cmd As Data.Common.DbCommand = rConn.CreateCommand

        Cmd.CommandText = "DELETE FROM " & cTableName & " WHERE BacteriaID=@pBacteriaID"

        CommandParamAdd(Cmd, "pBacteriaID", DbType.Int32, vYeastID)

        Cmd.ExecuteNonQuery()

    End Sub

    'Purpose:
    Public Shared Function DBNextBacteriaID(ByRef rconn As Data.Common.DbConnection) As Integer


        Const cDefID = 1
        Dim DR As Data.Common.DbDataReader
        Dim Cmd As Data.Common.DbCommand = rconn.CreateCommand

        Cmd.CommandText = "SELECT Max(BacteriaID) from " & cTableName

        DR = Cmd.ExecuteReader

        If DR.HasRows = True Then
            DR.Read()

            If DR.IsDBNull(0) = True Then
                DBNextBacteriaID = cDefID
            Else
                DBNextBacteriaID = DR.GetInt32(0) + 1
            End If

        Else
            DBNextBacteriaID = cDefID
        End If

        DR.Close()

    End Function


#End Region





End Class
