
Imports LabDB.DBSaber.StdTools



'Purpose: Represents a cell line

Public Class CellLine


#Region " Member Variables "

    Private m_CellLineID As Integer
    Private m_LabName As String = ""
    Private m_RecDate As Date = Now
    Private m_CellLineName As String = ""
    Private m_FormerName As String = ""
    Private m_Species As String = ""
    Private m_TissueType As String = ""
    Private m_Donor As String = ""
    Private m_Modification As String = ""
    Private m_PassageNumber As String = ""
    Private m_NumberOfVials As Integer
    Private m_Source As String = ""
    Private m_StorageLocation As String = ""
    Private m_PreferredMedium As String = ""

    Private m_Comments As String = ""
    Private m_CustomField1 As String = ""
    Private m_CustomField2 As String = ""
    Private m_LastModified As Date = Now


    Public Const cTableName As String = "tblCellLine"


#End Region


#Region " Properties "

    Public Property CellLineID() As Integer
        Get
            Return Me.m_CellLineID
        End Get
        Set(ByVal value As Integer)
            Me.m_CellLineID = value
        End Set
    End Property

    Public Property LabName() As String
        Get
            Return Me.m_LabName
        End Get
        Set(ByVal value As String)
            Me.m_LabName = value
        End Set
    End Property

    Public Property RecDate() As Date
        Get
            Return Me.m_RecDate
        End Get
        Set(ByVal value As Date)
            Me.m_RecDate = value
        End Set
    End Property


    Public Property CellLineName() As String
        Get
            Return Me.m_CellLineName
        End Get
        Set(ByVal value As String)
            Me.m_CellLineName = value
        End Set
    End Property

    Public Property FormerName() As String
        Get
            Return Me.m_FormerName
        End Get
        Set(ByVal value As String)
            Me.m_FormerName = value
        End Set
    End Property

    Public Property Species() As String
        Get
            Return Me.m_Species
        End Get
        Set(ByVal value As String)
            Me.m_Species = value
        End Set
    End Property

    Public Property TissueType() As String
        Get
            Return Me.m_TissueType
        End Get
        Set(ByVal value As String)
            Me.m_TissueType = value
        End Set
    End Property

    Public Property Donor() As String
        Get
            Return Me.m_Donor
        End Get
        Set(ByVal value As String)
            Me.m_Donor = value
        End Set
    End Property

    Public Property Modification() As String
        Get
            Return Me.m_Modification
        End Get
        Set(ByVal value As String)
            Me.m_Modification = value
        End Set
    End Property

    Public Property PassageNumber() As String
        Get
            Return Me.m_PassageNumber
        End Get
        Set(ByVal value As String)
            Me.m_PassageNumber = value
        End Set
    End Property

    Public Property NumberOfVials() As Integer
        Get
            Return Me.m_NumberOfVials
        End Get
        Set(ByVal value As Integer)
            Me.m_NumberOfVials = value
        End Set
    End Property

    Public Property Source() As String
        Get
            Return Me.m_Source
        End Get
        Set(ByVal value As String)
            Me.m_Source = value
        End Set
    End Property

    Public Property StorageLocation() As String
        Get
            Return Me.m_StorageLocation
        End Get
        Set(ByVal value As String)
            Me.m_StorageLocation = value
        End Set
    End Property

    Public Property PreferredMedium() As String
        Get
            Return Me.m_PreferredMedium
        End Get
        Set(ByVal value As String)
            Me.m_PreferredMedium = value
        End Set
    End Property

    Public Property Comments() As String
        Get
            Return Me.m_Comments
        End Get
        Set(ByVal value As String)
            Me.m_Comments = value
        End Set
    End Property

    Public Property CustomField1() As String
        Get
            Return Me.m_CustomField1
        End Get
        Set(ByVal value As String)
            Me.m_CustomField1 = value
        End Set
    End Property

    Public Property CustomField2() As String
        Get
            Return Me.m_CustomField2
        End Get
        Set(ByVal value As String)
            Me.m_CustomField2 = value
        End Set
    End Property

    Public ReadOnly Property LastModified() As Date
        Get
            Return Me.m_LastModified
        End Get
    End Property


    Public ReadOnly Property FullName() As String
        Get
            Return Me.LabName & "-" & String.Format("{0:00000}", Me.CellLineID)
        End Get
    End Property

#End Region


#Region " Constructors "

    Public Sub New()

    End Sub

    Public Sub New(ByRef rConn As Data.Common.DbConnection, ByVal vCellLineID As Integer)

        Me.DBLoad(rConn, vCellLineID)

    End Sub

    Public Sub New(ByRef rRS As Data.Common.DbDataReader)

        Me.RSLoad(rRS)

    End Sub

#End Region


#Region " Database Support "


    Public Sub DBLoad(ByRef rConn As Data.Common.DbConnection, ByVal vCellLineID As Integer)

        Dim RS As Data.Common.DbDataReader
        Dim Cmd As Data.Common.DbCommand = rConn.CreateCommand


        Cmd.CommandText = "SELECT * FROM " & cTableName & " WHERE CellLineID=@pCellLineID"
        CommandParamAdd(Cmd, "pCellLineID", DbType.Int32, vCellLineID)

        RS = Cmd.ExecuteReader


        If RS.HasRows = True Then
            RS.Read()
            Me.RSLoad(RS)
            RS.Close()
        Else
            'Couldn't find it in the table
            Throw New DBSaber.NoRecordFoundDBException(cTableName, "CellLineID", vCellLineID)
            RS.Close()
        End If


    End Sub

    Public Sub RSLoad(ByRef rRS As Data.Common.DbDataReader)

        Me.m_CellLineID = rRS.GetInt32(0)
        Me.m_LabName = DBValStr(rRS, 1)
        Me.m_RecDate = DBValDate(rRS, 2)
        Me.m_CellLineName = DBValStr(rRS, 3)
        Me.m_FormerName = DBValStr(rRS, 4)
        Me.m_Species = DBValStr(rRS, 5)
        Me.m_TissueType = DBValStr(rRS, 6)
        Me.m_Donor = DBValStr(rRS, 7)
        Me.m_Modification = DBValStr(rRS, 8)
        Me.m_PassageNumber = DBValStr(rRS, 9)

        Me.m_NumberOfVials = rRS.GetInt16(10)
        Me.m_Source = DBValStr(rRS, 11)
        Me.m_StorageLocation = DBValStr(rRS, 12)
        Me.m_PreferredMedium = DBValStr(rRS, 13)
        Me.m_Comments = DBValStr(rRS, 14)
        Me.m_CustomField1 = DBValStr(rRS, 15)
        Me.m_CustomField2 = DBValStr(rRS, 16)
        Me.m_LastModified = DBValDate(rRS, 17)

    End Sub

    Public Sub DBSave(ByRef rConn As OleDb.OleDbConnection)


        Dim SQL As String
        'Dim DR As Data.Common.DbDataReader
        Dim Cmd As OleDb.OleDbCommand = rConn.CreateCommand


        If Me.CellLineID = 0 Then

            Me.m_LastModified = Now


            'Insert

            SQL = "INSERT INTO " & cTableName & " (LabName, RecDate, CellLineName, FormerName, Species, TissueType, Donor, Modification, PassageNumber, NumberOfVials, Source, StorageLocation, PreferredMedium, Comments, CustomField1, CustomField2, LastModified) VALUES ("
            SQL = SQL & "@pLabName, @pRecDate, @pCellLineName, @pFormerName, @pSpecies, @pTissueType, @pDonor, @pModification, @pPassageNumber, @pNumberOfVials, @pSource, @pStorageLocation, @pPrefferedMedium, @pComments, @pCustomField1, @pCustomField2, @pLastModified)"


            Cmd.CommandText = SQL

            CommandParamAdd(Cmd, "pLabName", DbType.String, Me.LabName)
            CommandParamAdd(Cmd, "pRecDate", DbType.String, Me.RecDate)
            CommandParamAdd(Cmd, "pCellLineName", DbType.String, Me.CellLineName)
            CommandParamAdd(Cmd, "pFormerName", DbType.String, Me.FormerName)
            CommandParamAdd(Cmd, "pSpecies", DbType.String, Me.Species)
            CommandParamAdd(Cmd, "pTissueType", DbType.String, Me.TissueType)
            CommandParamAdd(Cmd, "pDonor", DbType.String, Me.Donor)
            CommandParamAdd(Cmd, "pModification", DbType.String, Me.Modification)
            CommandParamAdd(Cmd, "pPassageNumber", DbType.String, Me.PassageNumber)
            CommandParamAdd(Cmd, "pNumberOfVials", DbType.Int32, Me.NumberOfVials)
            CommandParamAdd(Cmd, "pSource", DbType.String, Me.Source)
            CommandParamAdd(Cmd, "pStorageLocation", DbType.String, Me.StorageLocation)
            CommandParamAdd(Cmd, "pPreferredMedium", DbType.String, Me.PreferredMedium)

            CommandParamAdd(Cmd, "pComments", DbType.String, Me.Comments)
            CommandParamAdd(Cmd, "pCustomField1", DbType.String, Me.CustomField1)
            CommandParamAdd(Cmd, "pCustomField2", DbType.String, Me.CustomField2)
            CommandParamAdd(Cmd, "pLastModified", DbType.String, Me.m_LastModified)

            Cmd.ExecuteNonQuery()


            Me.CellLineID = DBSaber.StdTools.DBValue(rConn, "SELECT CellLineID FROM " & cTableName & " WHERE LastModified=@pLastModified", "@pLastModified", DbType.String, Me.LastModified)


        Else
            'Update

            Me.m_LastModified = Now

            SQL = "UPDATE " & cTableName & " SET LabName=@pLabName, RecDate=@pRecDate, CellLineName=@pCellLineName, FormerName=@pFormerName, Species=@pSpecies, TissueType=@pTissueType, Donor=@pDonor"
            SQL = SQL & ",Modification=@pModification, PassageNumber=@pPassageNumber, NumberOfVials=@pNumberOfVials"
            SQL = SQL & ",Source=@pSource, StorageLocation=@pStorageLocation, PreferredMedium=@pPrefferedMedium"
            SQL = SQL & ", Comments=@pComments, CustomField1=@pCustomField1, CustomField2=@pCustomField2, LastModified=@pLastModified"
            SQL = SQL & " WHERE CellLineID=@pCellLineID"

            Cmd.CommandText = SQL

            CommandParamAdd(Cmd, "pLabName", DbType.String, Me.LabName)
            CommandParamAdd(Cmd, "pRecDate", DbType.String, Me.RecDate)
            CommandParamAdd(Cmd, "pCellLineName", DbType.String, Me.CellLineName)
            CommandParamAdd(Cmd, "pFormerName", DbType.String, Me.FormerName)
            CommandParamAdd(Cmd, "pSpecies", DbType.String, Me.Species)
            CommandParamAdd(Cmd, "pTissueType", DbType.String, Me.TissueType)
            CommandParamAdd(Cmd, "pDonor", DbType.String, Me.Donor)
            CommandParamAdd(Cmd, "pModification", DbType.String, Me.Modification)
            CommandParamAdd(Cmd, "pPassageNumber", DbType.String, Me.PassageNumber)
            CommandParamAdd(Cmd, "pNumberOfVials", DbType.Int32, Me.NumberOfVials)
            CommandParamAdd(Cmd, "pSource", DbType.String, Me.Source)
            CommandParamAdd(Cmd, "pStorageLocation", DbType.String, Me.StorageLocation)
            CommandParamAdd(Cmd, "pPreferredMedium", DbType.String, Me.PreferredMedium)

            CommandParamAdd(Cmd, "pComments", DbType.String, Me.Comments)
            CommandParamAdd(Cmd, "pCustomField1", DbType.String, Me.CustomField1)
            CommandParamAdd(Cmd, "pCustomField2", DbType.String, Me.CustomField2)
            CommandParamAdd(Cmd, "pLastModified", DbType.String, Me.m_LastModified)

            CommandParamAdd(Cmd, "pCellLineId", DbType.Int32, Me.CellLineID)

            Cmd.ExecuteNonQuery()

        End If


    End Sub


    Public Shared Function DBCellLines(ByRef rConn As Data.Common.DbConnection) As Generic.List(Of CellLine)

        Dim Cmd As Data.Common.DbCommand = rConn.CreateCommand
        Dim RS As Data.Common.DbDataReader
        Dim tCollect As New Generic.List(Of CellLine)

        Cmd.CommandText = "SELECT * FROM " & cTableName & " ORDER BY CellLineID"


        RS = Cmd.ExecuteReader

        Do While RS.Read
            tCollect.Add(New CellLine(RS))
        Loop

        RS.Close()


        Return tCollect


    End Function


    ''' <summary>
    ''' Returns a list of all the query items
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Shared Function DBQItems() As Generic.List(Of SQLQueryItem)

        Dim tCollect As New Generic.List(Of SQLQueryItem)

        tCollect.Add(New SQLQueryItem("CellLine ID", "CellLineID", DbType.Int32, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Lab Name", "LabName", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))

        tCollect.Add(New SQLQueryItem("Cell Line Name", "CellLineName", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Former Name", "FormerName", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Storage Location", "StorageLocation", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Preferred Medium", "PreferredMedium", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Species", "Species", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Tissue Type", "TissueType", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Modification", "Modification", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Passage #", "PassageNumber", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))

        tCollect.Add(New SQLQueryItem("Comments", "Comments", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Custom Field 1", "CustomField1", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Custom Field 2", "CustomField2", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))


        Return tCollect


    End Function

    ''' <summary>
    ''' Removes a record from the database
    ''' </summary>
    ''' <param name="rConn"></param>
    ''' <param name="vCellLineID"></param>
    ''' <remarks></remarks>
    Public Shared Sub DBDelete(ByRef rConn As Data.Common.DbConnection, ByVal vCellLineID As Integer)

        Dim Cmd As Data.Common.DbCommand = rConn.CreateCommand

        Cmd.CommandText = "DELETE FROM " & cTableName & " WHERE CellLineID=@pCellLineID"

        CommandParamAdd(Cmd, "pCellLineID", DbType.Int32, vCellLineID)

        Cmd.ExecuteNonQuery()

    End Sub

    'Purpose:
    Public Shared Function DBNextCellLineID(ByRef rconn As Data.Common.DbConnection) As Integer

        Const cDefID As Integer = 1
        Dim DR As Data.Common.DbDataReader
        Dim Cmd As Data.Common.DbCommand = rconn.CreateCommand

        Cmd.CommandText = "SELECT Max(CellLineID) from " & cTableName

        DR = Cmd.ExecuteReader

        If DR.HasRows = True Then
            DR.Read()

            If DR.IsDBNull(0) = True Then
                DBNextCellLineID = cDefID
            Else
                DBNextCellLineID = DR.GetInt32(0) + 1
            End If


        Else
            DBNextCellLineID = cDefID
        End If

        DR.Close()

    End Function


#End Region


End Class
