
''' <summary>
''' Various tools for working with windows forms.
''' </summary>
''' <remarks></remarks>
Public Class FormSaber



    ''' <summary>
    ''' Determines if a form is already open
    ''' </summary>
    ''' <param name="vFormName">The name of the form</param>
    ''' <param name="vActivateIfFound">Activates the form if found</param>
    ''' <returns>True if the form is already open</returns>
    ''' <remarks></remarks>
    Public Shared Function FormIsOpen(ByVal vFormName As String, Optional ByVal vActivateIfFound As Boolean = True) As Boolean

        For Each tForm As Form In My.Application.OpenForms


            If tForm.Name = vFormName Then
                'Form names match so found the form
                If vActivateIfFound = True Then
                    'Activating the form.
                    tForm.Activate()

                End If

                Return True

            End If

        Next

        'Made it this far
        Return False

    End Function

End Class





