

'ToDO: Check 468 oligo id record sequence


Public Class GenDec



#Region " member variables "


    Public Enum FormMode
        ModeAdd = 1
        ModeEdit
        ModeA
        ModeB
        ModeC
        ModeD
    End Enum


    Public Const cFormatDate As String = "{0:d}"


#End Region


    Public Shared ReadOnly Property INIFileName() As String
        Get
            Return Application.StartupPath & "\Settings.INI"
        End Get
    End Property

    'Purpose: Performs standard list item placement. Eventually this will be tacked
    '         straight onto 
    '
    'Note: This is typically used in a local listview item load
    '
    'vItem: The listview item to place on the listview
    '
    'vIndex: The position to place the item. -1 will add to the end of the listview
    '
    'vSelect: 1 will select the item
    '
    'vRemItem: 1 will remove the item in vIndex BEFORE placing vItem
    Public Shared Sub LVWItemPlace(ByRef rLVW As ListView, ByRef vItem As ListViewItem, Optional ByVal vIndex As Integer = -1, Optional ByVal vSelect As Byte = 0, Optional ByVal vRemItem As Integer = 0)


        If vIndex > -1 And vRemItem = 1 Then
            'Removing the item in the slot. Will be added 
            Call rLVW.Items.RemoveAt(vIndex)

        End If



        If vIndex = -1 Then
            'Adding to the end
            Call rLVW.Items.Add(vItem)
        Else
            'Inserting at a specific index
            Call rLVW.Items.Insert(vIndex, vItem)

        End If


        If vSelect = 1 Then
            'Selecting the Ite
            vItem.Selected = True
            Call vItem.EnsureVisible()
        End If

    End Sub


End Class



'Purpose: Cotains useful methods for dealing with User Form Settings
'
'Note: Save positions of the form, size, listview sizes
Public Class UFS


#Region "ListView Support"

    'Purpose:  Saves all the column header widths on the lvw
    '
    'Note:  Saves the Column Heads as "34, 241, 69, " to be used with
    '       the function array

    Public Shared Sub LVWColsSave(ByRef rLVW As ListView, ByVal vINIPath As String, ByVal vINISectionName As String, Optional ByVal vINIKeyName As String = "")

        Dim Col As ColumnHeader
        Dim ColWidthString As String = "" 'comma delimited string of their col widths
        'Dim INIKeyName As String
        Dim tINI As New INIAccess

        ''Checking if the specified the KeyName
        'If vINIKeyName = "" Then
        '    INIKeyName = "Columns" 'Use the default keyname
        'Else
        '    INIKeyName = vINIKeyName 'use their keyname
        'End If

        If vINIKeyName = "" Then
            vINIKeyName = rLVW.Name
        End If

        'Cycling through all the columns in rlvw
        For Each Col In rLVW.Columns

            'Creating a string
            ColWidthString = ColWidthString & CStr(Col.Width) & ", "

        Next Col

        'If ColWidthString <> "" Then
        '    ColWidthString = ColWidthString.Substring(0, ColWidthString.Length - 2)
        'End If

        'Saving to the ini file
        INIAccess.INIWrite(vINIPath, vINISectionName, vINIKeyName, ColWidthString)

    End Sub

    ''' <summary>
    ''' 
    ''' </summary>
    ''' <param name="rLVW"></param>
    ''' <param name="vINIPath"></param>
    ''' <param name="vINISectionName"></param>
    ''' <param name="vINIKeyName"></param>
    ''' <remarks></remarks>
    Public Shared Sub LVWColsLoad(ByRef rLVW As ListView, ByVal vINIPath As String, ByVal vINISectionName As String, Optional ByVal vINIKeyName As String = "")

        Dim Col As ColumnHeader
        Dim ColWidths As Object  'TempArray for all the column headers
        Dim Counter1 As Byte
        'Dim INIKeyName As String
        Dim ColWidthString As String
        Dim tINI As New INIAccess


        If vINIKeyName = "" Then
            vINIKeyName = rLVW.Name
        End If


        ColWidthString = INIAccess.INIRead(vINIPath, vINISectionName, vINIKeyName, "")

        'They didn't have a valid list of column widths
        If ColWidthString = "" Then Exit Sub


        'Try
        'Turning the string into an array (easier to cycle through)
        ColWidths = Split(ColWidthString, ",")

        'Cycling through all the columnheaders in rLVW
        For Each Col In rLVW.Columns

            Try
                Col.Width = ColWidths(Counter1)
            Catch ex As Exception

            End Try


            'Incrementing
            Counter1 = Counter1 + 1

        Next Col

        'Catch ex As Exception

        'End Try



    End Sub


#End Region


#Region "Form Support"


    'Purpose:
    '
    'vIncLVW:
    '
    'Note:
    Public Shared Sub FormSave(ByRef rForm As Windows.Forms.Form, ByVal vINIPath As String, Optional ByVal vINISectionName As String = "", Optional ByVal vIncLVW As Byte = 0)

        Dim tINI As New INIAccess


        If vINISectionName = "" Then
            vINISectionName = rForm.Name
        End If


        INIAccess.INIWrite(vINIPath, vINISectionName, "top", rForm.Top)
        INIAccess.INIWrite(vINIPath, vINISectionName, "left", rForm.Left)

        'Checking if the form is sizable
        If rForm.FormBorderStyle = FormBorderStyle.Sizable Then
            INIAccess.INIWrite(vINIPath, vINISectionName, "width", rForm.Width)
            INIAccess.INIWrite(vINIPath, vINISectionName, "height", rForm.Height)
            INIAccess.INIWrite(vINIPath, vINISectionName, "windowstate", rForm.WindowState)
        End If




        'ToDo: add support for controls containg controls

        'Possibly bring in all the listviews
        If vIncLVW = 1 Then
            Dim tCon As Control
            Dim tLVW As New ListView
            Dim TheType As String = tLVW.GetType.FullName 'The controls fullname for listview

            For Each tCon In ControlList(rForm.Controls)
                'Going through all the controls on the form looking for a listview

                If tCon.GetType.FullName = TheType Then
                    'Found a list view

                    Call LVWColsSave(tCon, vINIPath, vINISectionName)


                    tLVW = CType(tCon, ListView)

                    'Checking if there is a selected item
                    If tLVW.SelectedItems.Count > 0 Then
                        Call INIAccess.INIWrite(vINIPath, vINISectionName, tCon.Name & "-SelIndex", tLVW.SelectedItems(0).Index)
                    Else
                        Call INIAccess.INIWrite(vINIPath, vINISectionName, tCon.Name & "-SelIndex", -1)
                    End If

                End If 'tCon.GetType.FullName = TheType

            Next 'tCon 


        End If


    End Sub

    'Purpose: Loads ups a form
    '
    'vIncLVW
    Public Shared Sub FormLoad(ByRef rForm As Windows.Forms.Form, ByVal vINIPath As String, Optional ByVal vINISectionName As String = "", Optional ByVal vIncLVW As Byte = 0, Optional ByVal vSelLvwSelIndex As Byte = 0)

        Dim tINI As New INIAccess
        Const cDefLeft As Integer = 100
        Const cDefTop As Integer = 100
        Const cDefWidth As Integer = 500
        Const cDefHeight As Integer = 100
        'Dim tDec As Decimal


        If vINISectionName = "" Then
            vINISectionName = rForm.Name
        End If

        'Making sure the startup position is set properly
        rForm.StartPosition = FormStartPosition.Manual

        'Reading in the left and top coordinates
        rForm.Left = INIAccess.INIRead(vINIPath, vINISectionName, "left", cDefLeft)
        rForm.Top = INIAccess.INIRead(vINIPath, vINISectionName, "top", cDefTop)




        If rForm.FormBorderStyle = FormBorderStyle.Sizable Then
            'Loading the form's height and width
            'Note: If the value is not found in the ini file then the form is not resized

            Dim tint As Integer


            'setting
            '0 = default to normal
            rForm.WindowState = INIAccess.INIRead(vINIPath, vINISectionName, "windowstate", "0")

            If rForm.WindowState = FormWindowState.Maximized Then

            Else
                tint = INIAccess.INIRead(vINIPath, vINISectionName, "width", -1)

                If tint <> -1 Then
                    rForm.Width = tint
                End If

                tint = INIAccess.INIRead(vINIPath, vINISectionName, "height", -1)

                If tint <> -1 Then
                    rForm.Height = tint
                End If
            End If






        End If


        If vIncLVW = 1 Then
            'Include any listviews

            Dim tCon As Control
            Dim tLVW As New ListView
            Dim TheType As String = tLVW.GetType.FullName 'The controls fullname for listview

            For Each tCon In ControlList(rForm.Controls)
                If tCon.GetType.FullName = TheType Then

                    tLVW = CType(tCon, ListView)

                    Call LVWColsLoad(tCon, vINIPath, vINISectionName)

                End If

            Next


            If vSelLvwSelIndex = 1 Then
                'Highlighting their last selected index

                Dim tSelIndex As Integer

                'Retrieving the last selected index from the ini file
                tSelIndex = INIAccess.INIRead(vINIPath, vINISectionName, tLVW.Name & "-SelIndex", -1)

                'Checking to make sure it is a valid range for the listview
                If tSelIndex <> -1 And tSelIndex <= tLVW.Items.Count Then
                    tLVW.Items(tSelIndex).Selected = True
                    Call tLVW.EnsureVisible(tSelIndex)
                End If

            End If

        End If



    End Sub

    'Purpose: Finds all the controls in a control collection
    '
    'Note: Does recursion to find controls within controls. The standard controls of a form
    '
    'Note: I couldn't find an easy way to do this in VB.NET

    Public Shared Function ControlList(ByRef rControlCollect As Control.ControlCollection) As Collection

        Dim tControl As Control
        Dim tCollect As New Collection

        For Each tControl In rControlCollect
            Dim sControl As Control

            tCollect.Add(tControl)

            For Each sControl In ControlList(tControl.Controls)

                tCollect.Add(sControl)
            Next

        Next

        Return tCollect

    End Function


#End Region


End Class



'Purpose: Allows INI file reading and writing
'
'Note: Just wraps up the usual win32 api calls
'
'Note: obtained from: http://www.utmag.com/May2003/Page61.asp
'
'

Public Class INIAccess

#Region "API Calls"
    ' standard API declarations for INI access
    Private Declare Unicode Function WritePrivateProfileString _
                            Lib "kernel32" _
                            Alias "WritePrivateProfileStringW" _
                            (ByVal lpApplicationName As String, _
                             ByVal lpKeyName As String, _
                             ByVal lpString As String, _
                             ByVal lpFileName As String) As Int32
    Private Declare Unicode Function GetPrivateProfileString _
                            Lib "kernel32" _
                            Alias "GetPrivateProfileStringW" _
                            (ByVal lpApplicationName As String, _
                             ByVal lpKeyName As String, _
                             ByVal lpDefault As String, _
                             ByVal lpReturnedString As String, _
                             ByVal nSize As Int32, _
                             ByVal lpFileName As String) As Int32
#End Region

#Region "--- INIRead ---"
    Public Overloads Shared Function INIRead(ByVal INIPath As String, ByVal SectionName As String, ByVal KeyName As String, ByVal DefaultValue As String) As String
        ' primary version of call gets single value given all parameters
        Dim n As Int32
        Dim sData As String

        sData = Space$(1024) ' allocate some room 
        n = GetPrivateProfileString(SectionName, KeyName, DefaultValue, sData, sData.Length, INIPath)
        If n > 0 Then ' return whatever it gave us
            INIRead = sData.Substring(0, n)
        Else
            INIRead = ""
        End If
    End Function

    Public Overloads Shared Function INIRead(ByVal INIPath As String, _
      ByVal SectionName As String, ByVal KeyName As String) As String
        ' overload 1 assumes zero-length default
        Return INIRead(INIPath, SectionName, KeyName, "")
    End Function

    Public Overloads Shared Function INIRead(ByVal INIPath As String, ByVal SectionName As String) As String
        ' overload 2 returns all keys in a given section of the given file
        Return INIRead(INIPath, SectionName, Nothing, "")
    End Function

    Public Overloads Shared Function INIRead(ByVal INIPath As String) As String
        ' overload 3 returns all section names given just path
        Return INIRead(INIPath, Nothing, Nothing, "")
    End Function
#End Region

#Region "--- INIWrite ---"
    Public Shared Sub INIWrite(ByVal INIPath As String, ByVal SectionName As String, ByVal KeyName As String, ByVal TheValue As String)
        Call WritePrivateProfileString(SectionName, KeyName, TheValue, INIPath)
    End Sub
#End Region

#Region "--- INIDelete ---"
    Public Overloads Shared Sub INIDelete(ByVal INIPath As String, ByVal SectionName As String, ByVal KeyName As String)       ' delete single line from section
        Call WritePrivateProfileString(SectionName, KeyName, Nothing, INIPath)
    End Sub

    Public Overloads Shared Sub INIDelete(ByVal INIPath As String, ByVal SectionName As String)
        ' delete section from INI file
        Call WritePrivateProfileString(SectionName, Nothing, Nothing, INIPath)
    End Sub
#End Region


End Class

