Imports System.Windows.Forms


Public Class frmNewMain


#Region " Member Variables "


    Public Shared Conn As Data.Common.DbConnection


    Public Shared DBPath As String = ""

    'Oligo Specific 
    Public Shared OligoEnabled As Boolean
    Public Shared OligoLabSuffix As String = ""
    Public Shared OligoCustomField1 As String = "Custom Field 1"
    Public Shared OligoCustomField2 As String = "Custom Field 2"

    Public Shared OligoMOfNaCl As Single
    Public Shared OligoPerFormamide As Single


    'Yeast 
    Public Shared YeastEnabled As Boolean
    Public Shared YeastLabSuffix As String = ""
    Public Shared YeastCustomField1 As String = "Custom Field 1"
    Public Shared YeastCustomField2 As String = "Custom Field 2"

    'Bacteria
    Public Shared BacteriaEnabled As Boolean
    Public Shared BacteriaLabSuffix As String = ""
    Public Shared BacteriaCustomField1 As String = "Custom Field 1"
    Public Shared BacteriaCustomField2 As String = "Custom Field 2"

    'Cells
    Public Shared CellLineEnabled As Boolean
    Public Shared CellLineLabSuffix As String = ""
    Public Shared CellLineCustomField1 As String = "Custom Field 1"
    Public Shared CellLineCustomField2 As String = "Custom Field 2"


    Private m_ChildFormNumber As Integer = 0


#End Region


    Private Sub mnuaSettings(ByVal sender As Object, ByVal e As EventArgs) Handles mnuSettings.Click
        ' Create a new instance of the child form.
        'Dim ChildForm As New System.Windows.Forms.Form
        '' Make it a child of this MDI form before showing it.
        'ChildForm.MdiParent = Me

        'm_ChildFormNumber += 1
        'ChildForm.Text = "Window " & m_ChildFormNumber

        'ChildForm.Show()


        Dim Blah As New frmSettings

        Blah.ShowDialog()


        'checking if they changed the database



        'Enabling or disablign buttons
        Me.btnOligo.Enabled = OligoEnabled
        Me.btnYeasts.Enabled = YeastEnabled
        Me.btnBacteria.Enabled = BacteriaEnabled
        Me.btnCellLine.Enabled = CellLineEnabled

    End Sub


#Region " MDI Builtin Toolbar Events "

    Private Sub ExitToolsStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles mnuExit.Click
        Global.System.Windows.Forms.Application.Exit()
    End Sub

    Private Sub ToolBarToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles ToolBarToolStripMenuItem.Click
        Me.ToolStrip.Visible = Me.ToolBarToolStripMenuItem.Checked
    End Sub

    Private Sub CascadeToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CascadeToolStripMenuItem.Click
        Me.LayoutMdi(MdiLayout.Cascade)
    End Sub

    Private Sub TileVerticleToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles TileVerticalToolStripMenuItem.Click
        Me.LayoutMdi(MdiLayout.TileVertical)
    End Sub

    Private Sub TileHorizontalToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles TileHorizontalToolStripMenuItem.Click
        Me.LayoutMdi(MdiLayout.TileHorizontal)
    End Sub

    Private Sub ArrangeIconsToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.LayoutMdi(MdiLayout.ArrangeIcons)
    End Sub

    Private Sub CloseAllToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CloseAllToolStripMenuItem.Click
        ' Close all child forms of the parent.
        For Each ChildForm As Form In Me.MdiChildren
            ChildForm.Close()
        Next
    End Sub

    Private Sub AboutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutToolStripMenuItem.Click

        Dim tAboutForm As New frmAbout

        tAboutForm.ShowDialog()

    End Sub

#End Region



#Region " Form Events "



    Private Sub frmNewMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load



        'Loding up their settings
        DBPath = INIAccess.INIRead(GenDec.INIFileName, "frmMain", "DBPath", "")
        OligoLabSuffix = INIAccess.INIRead(GenDec.INIFileName, "frmMain", "LabNamePrefix", "")


        'Oligos
        OligoEnabled = INIAccess.INIRead(GenDec.INIFileName, "frmMain", "OligoEnabled", "True")
        OligoLabSuffix = INIAccess.INIRead(GenDec.INIFileName, "frmMain", "OligoLabSuffix", "")
        OligoCustomField1 = INIAccess.INIRead(GenDec.INIFileName, "frmMain", "OligoCustomField1", "")
        OligoCustomField2 = INIAccess.INIRead(GenDec.INIFileName, "frmMain", "OligoCustomField2", "")

        OligoMOfNaCl = INIAccess.INIRead(GenDec.INIFileName, "frmMain", "OligoMOfNaCl", ".375")
        OligoPerFormamide = INIAccess.INIRead(GenDec.INIFileName, "frmMain", "OligoPerFormamide", "0")


        'Yeast
        YeastEnabled = INIAccess.INIRead(GenDec.INIFileName, "frmMain", "YeastEnabled", "True")
        YeastLabSuffix = INIAccess.INIRead(GenDec.INIFileName, "frmMain", "YeastLabSuffix", "")
        YeastCustomField1 = INIAccess.INIRead(GenDec.INIFileName, "frmMain", "YeastCustomField1", "")
        YeastCustomField2 = INIAccess.INIRead(GenDec.INIFileName, "frmMain", "YeastCustomField2", "")

        'Bacteria
        BacteriaEnabled = INIAccess.INIRead(GenDec.INIFileName, "frmMain", "BacteriaEnabled", "True")
        BacteriaLabSuffix = INIAccess.INIRead(GenDec.INIFileName, "frmMain", "BacteriaLabSuffix", "")
        BacteriaCustomField1 = INIAccess.INIRead(GenDec.INIFileName, "frmMain", "BacteriaCustomField1", "")
        BacteriaCustomField2 = INIAccess.INIRead(GenDec.INIFileName, "frmMain", "BacteriaCustomField2", "")

        'Cells
        CellLineEnabled = INIAccess.INIRead(GenDec.INIFileName, "frmMain", "CellLineEnabled", "True")
        CellLineLabSuffix = INIAccess.INIRead(GenDec.INIFileName, "frmMain", "CellLineLabSuffix", "")
        CellLineCustomField1 = INIAccess.INIRead(GenDec.INIFileName, "frmMain", "CellLineCustomField1", "")
        CellLineCustomField2 = INIAccess.INIRead(GenDec.INIFileName, "frmMain", "CellLineCustomField2", "")


        'Enabling or disablign buttons depending on their settings
        Me.btnOligo.Enabled = OligoEnabled
        Me.btnYeasts.Enabled = YeastEnabled
        Me.btnBacteria.Enabled = BacteriaEnabled
        Me.btnCellLine.Enabled = CellLineEnabled


        If ConnectToDB(DBPath) = False Then

            Dim Blah As New frmSettings

            If Blah.ShowDialog() <> Windows.Forms.DialogResult.OK Then
                'They didn't select a database so close down the program. There is nothing they could really do with lina if they don't have
                'a valid database

                MessageBox.Show("Lina is closing now because a Database wasn't selected.", "Lina Closing", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Me.Close()

            Else
                'They selected the database

                'Since this is a first startup

                ConnectToDB(DBPath)

            End If


        Else

 

        End If


        'Loading the form position information for lina
        UFS.FormLoad(Me, GenDec.INIFileName)



        'retrieving the what forms where open at program shutdown from the ini file. Names are sperated by ","
        Dim FormsOpen As String() = INIAccess.INIRead(GenDec.INIFileName, Me.Name, "FormsOpen", "").Split(",")

        'Cycling through all the form names that where in the forms open setting
        For Each tFormName As String In FormsOpen


            If tFormName = frmOligoList.Name Then

                btnOligos_Click(Nothing, Nothing)

            ElseIf tFormName = frmYeastList.Name Then

                Me.btnYeasts_Click(Nothing, Nothing)

            ElseIf tFormName = frmBacteriaList.Name Then

                btnBacteria_Click(Nothing, Nothing)

            ElseIf tFormName = frmCellLineList.Name Then

                Me.btnCellLine_Click(Nothing, Nothing)

            End If

        Next


    End Sub


    Private Sub frmNewMain_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        Dim tFormsOpen As String = "" 'stores the form open setting string in format (formname, form2, etc)


        'Creating the setting string for which forms the user has open at when they shut down the program.
        'That way we know which ones to open on program startup.

        If FormSaber.FormIsOpen(frmOligoList.Name) = True Then
            tFormsOpen = tFormsOpen & frmOligoList.Name & ","
        End If

        If FormSaber.FormIsOpen(frmYeastList.Name) = True Then
            tFormsOpen = tFormsOpen & frmYeastList.Name & ","
        End If

        If FormSaber.FormIsOpen(frmBacteriaList.Name) = True Then
            tFormsOpen = tFormsOpen & frmBacteriaList.Name & ","
        End If

        If FormSaber.FormIsOpen(frmCellLineList.Name) = True Then
            tFormsOpen = tFormsOpen & frmCellLineList.Name & ","
        End If

        'Writing the forms open setting into the ini file.
        INIAccess.INIWrite(GenDec.INIFileName, Me.Name, "FormsOpen", tFormsOpen)


    End Sub

    Private Sub frmNewMain_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed


        UFS.FormSave(Me, GenDec.INIFileName, , 1)


    End Sub

#End Region



#Region " Misc Support "

    ''' <summary>
    ''' Connects to a file specified database
    ''' </summary>
    ''' <param name="vDBPath">The file path to the lab access database</param>
    ''' <returns>True if database connected</returns>
    ''' <remarks>Most of the connection string is builtin</remarks>
    Public Shared Function ConnectToDB(ByVal vDBPath As String) As Boolean


        If vDBPath = "" Then
            'no database found path during load up from their settings file
            MessageBox.Show("Specify a database.", "No database specfied", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return False
        End If

        Try
            'Incase they have one already open and are opening a different one closing their current one
            Conn.Close()
        Catch ex As Exception
            'most likely they didn't have a connection open.
        End Try

        'Instantiating with the oledbconnection because we are supporting access
        Conn = New OleDb.OleDbConnection


        'Creating the connection string in order to connect to the database
        Conn.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;" & "User ID=Admin;" & "Data Source=" & vDBPath & ";"

        Try
            Call Conn.Open() 'opening the database
            ConnectToDB = True 'returning
        Catch ex As Exception
            'There was a problem so informing the user about the error.
            MessageBox.Show(ex.Message, "Unable to connect to Database", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try

    End Function

#End Region


#Region " Control Events "

    Private Sub btnOligos_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOligo.Click


        Dim Blah As New frmOligoList
        Dim tCollect As New Collection

        If FormSaber.FormIsOpen(Blah.Name) = False Then
            Blah.MdiParent = Me
            Blah.paDialog(tCollect, GenDec.FormMode.ModeA)
        End If

    End Sub

    Private Sub btnYeasts_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnYeasts.Click

        Dim Blah As New frmYeastList
        Dim tCollect As New Collection

        If FormSaber.FormIsOpen(Blah.Name) = False Then
            Blah.MdiParent = Me
            Blah.paDialog(tCollect, GenDec.FormMode.ModeA)
        End If

    End Sub

    Private Sub btnBacteria_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBacteria.Click

        Dim Blah As New frmBacteriaList
        Dim tCollect As New Collection

        If FormSaber.FormIsOpen(Blah.Name) = False Then
            Blah.MdiParent = Me
            Blah.paDialog(tCollect, GenDec.FormMode.ModeA)
        End If

    End Sub

    Private Sub btnCellLine_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCellLine.Click

        Dim Blah As New frmCellLineList
        Dim tCollect As New Collection

        If FormSaber.FormIsOpen(Blah.Name) = False Then
            Blah.MdiParent = Me
            Blah.paDialog(tCollect, GenDec.FormMode.ModeA)
        End If

    End Sub

#End Region


End Class
