''' <summary>
''' Form used to display search options and specify terms for all the lists.
''' </summary>
''' <remarks></remarks>
Public Class frmSearch


    Private fCollect As Collection 'holds search results for passing around

    Private TheType As Object



#Region " Form Events "


    Private Sub frmSearch_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'UFS.FormLoad(Me, GenDec.INIFileName)


        'Need to keep these seperated because of object reference issues
        For Each tq1 As SQLQueryItem In CustomFieldNames(TheType.DBQItems)
            Me.cbxField1.Items.Add(tq1)
        Next

        For Each tq2 As SQLQueryItem In CustomFieldNames(TheType.DBQItems)
            Me.cbxField2.Items.Add(tq2)
        Next

        For Each tq3 As SQLQueryItem In CustomFieldNames(TheType.DBQItems)
            Me.cbxField3.Items.Add(tq3)
        Next

        For Each tq4 As SQLQueryItem In CustomFieldNames(TheType.DBQItems)
            Me.cbxField4.Items.Add(tq4)
        Next


        'Setting the type of search this will be
        If TypeOf Me.TheType Is Oligo Then
            Me.Text = "Serach Oligos"

        ElseIf TypeOf Me.TheType Is Yeast Then
            Me.Text = "Search Yeast"

        ElseIf TypeOf Me.TheType Is Bacteria Then
            Me.Text = "Search Bacteria"

        ElseIf TypeOf Me.TheType Is CellLine Then
            Me.Text = "Search Cell Lines"


        End If


    End Sub



    Private Sub frmSearch_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        'UFS.FormSave(Me, GenDec.INIFileName)

    End Sub



#End Region


    ''' <summary>
    ''' Creates some queryitem objects out of the custom fields.
    ''' </summary>
    ''' <param name="rCollect"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function CustomFieldNames(ByRef rCollect As Generic.List(Of SQLQueryItem)) As Generic.List(Of SQLQueryItem)

        If TypeOf Me.TheType Is Oligo Then
            rCollect(rCollect.Count - 2).DisplayFieldName = frmNewMain.OligoCustomField1
            rCollect(rCollect.Count - 1).DisplayFieldName = frmNewMain.OligoCustomField2

        ElseIf TypeOf Me.TheType Is Yeast Then
            rCollect(rCollect.Count - 2).DisplayFieldName = frmNewMain.YeastCustomField1
            rCollect(rCollect.Count - 1).DisplayFieldName = frmNewMain.YeastCustomField2

        ElseIf TypeOf Me.TheType Is Bacteria Then

            rCollect(rCollect.Count - 2).DisplayFieldName = frmNewMain.BacteriaCustomField1
            rCollect(rCollect.Count - 1).DisplayFieldName = frmNewMain.BacteriaCustomField2
        ElseIf TypeOf Me.TheType Is CellLine Then
            rCollect(rCollect.Count - 2).DisplayFieldName = frmNewMain.CellLineCustomField1
            rCollect(rCollect.Count - 1).DisplayFieldName = frmNewMain.BacteriaCustomField2
        End If


        Return rCollect

    End Function

    Public Function paDialog(ByRef TheType As Object, ByRef rCollect As Collection) As DialogResult

        Me.TheType = TheType
        Me.ShowDialog()


        If Me.DialogResult = Windows.Forms.DialogResult.OK Then
            rCollect = Me.fCollect
        End If


        Return Me.DialogResult


    End Function


#Region " Control Events "

    Private Sub btnSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSearch.Click


        Dim Cmd As Data.Common.DbCommand = frmNewMain.Conn.CreateCommand
        Dim blah As New SQLQueryBuild("SELECT * FROM " & TheType.cTableName)
        Dim DR As Data.Common.DbDataReader
        Dim tC As SQLQueryItem.eCatters
        Dim tItem1 As SQLQueryItem
        Dim tItem2 As SQLQueryItem
        Dim tItem3 As SQLQueryItem
        Dim tItem4 As SQLQueryItem


        'They must have the first value specified or it is ponitless to search, DUH
        If Me.cbxField1.Text = "" Then
            MessageBox.Show("Must Specify at least 1 field to search on", "", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Me.cbxField1.Focus()
            Exit Sub
        End If


        '****************************************
        'Value 1

        If Me.txtValue1.Text <> "" Then

            tItem1 = CType(Me.cbxField1.SelectedItem, SQLQueryItem)

            Me.txtValue1.Text = tItem1.OpPreProcess(Me.txtValue1.Text)

            'validate
            If tItem1.OpValid(Me.txtValue1.Text) = False Then
                MessageBox.Show("Invalid Operator for " & tItem1.DisplayFieldName, "", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Me.txtValue1.Focus()
                Exit Sub
            End If

            If tItem1.ValueValid(Me.txtValue1.Text) = False Then
                MessageBox.Show("Invalid value for " & tItem1.DisplayFieldName, "", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Me.txtValue1.Focus()
                Exit Sub
            End If

            tItem1.Value1 = Me.txtValue1.Text
            blah.QItems.Add(tItem1)

        End If



        '****************************************
        'Value 2

        If Me.txtValue2.Text <> "" Then


            tItem2 = CType(Me.cbxField2.SelectedItem, SQLQueryItem)

            'Selecting the combiner
            If Me.radV2CombinerAnd.Checked = True Then
                tC = SQLQueryItem.eCatters.CAnd
            Else
                tC = SQLQueryItem.eCatters.COr
            End If

            'Adding an operator if they don't have one
            Me.txtValue2.Text = tItem2.OpPreProcess(Me.txtValue2.Text)

            'validate
            If tItem2.OpValid(Me.txtValue2.Text) = False Then
                MessageBox.Show("Invalid Operator for " & tItem2.DisplayFieldName, "", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Me.txtValue2.Focus()
                Exit Sub
            End If

            If tItem2.ValueValid(Me.txtValue2.Text) = False Then
                MessageBox.Show("Invalid value for " & tItem2.DisplayFieldName, "", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Me.txtValue2.Focus()
                Exit Sub
            End If


            tItem2.Combiner = tC
            tItem2.Value1 = Me.txtValue2.Text
            blah.QItems.Add(tItem2)

        End If



        '****************************************
        'Value 3

        If Me.txtValue3.Text <> "" Then


            tItem3 = CType(Me.cbxField3.SelectedItem, SQLQueryItem)

            'Selecting the combiner
            If Me.radV3CombinerAnd.Checked = True Then
                tC = SQLQueryItem.eCatters.CAnd
            Else
                tC = SQLQueryItem.eCatters.COr
            End If

            'Adding an operator if they don't have one
            Me.txtValue3.Text = tItem3.OpPreProcess(Me.txtValue3.Text)

            'validate
            If tItem3.OpValid(Me.txtValue3.Text) = False Then
                MessageBox.Show("Invalid Operator for " & tItem3.DisplayFieldName, "", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Me.txtValue3.Focus()
                Exit Sub
            End If

            If tItem3.ValueValid(Me.txtValue3.Text) = False Then
                MessageBox.Show("Invalid value for " & tItem3.DisplayFieldName, "", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Me.txtValue3.Focus()
                Exit Sub
            End If


            tItem3.Combiner = tC
            tItem3.Value1 = Me.txtValue3.Text
            blah.QItems.Add(tItem3)

        End If



        '****************************************
        'Value 3

        If Me.txtValue4.Text <> "" Then


            tItem4 = CType(Me.cbxField4.SelectedItem, SQLQueryItem)

            'Selecting the combiner
            If Me.radV4CombinerAnd.Checked = True Then
                tC = SQLQueryItem.eCatters.CAnd
            Else
                tC = SQLQueryItem.eCatters.COr
            End If

            'Adding an operator if they don't have one
            Me.txtValue4.Text = tItem4.OpPreProcess(Me.txtValue4.Text)

            'validate
            If tItem4.OpValid(Me.txtValue4.Text) = False Then
                MessageBox.Show("Invalid Operator for " & tItem4.DisplayFieldName, "", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Me.txtValue4.Focus()
                Exit Sub
            End If

            If tItem4.ValueValid(Me.txtValue4.Text) = False Then
                MessageBox.Show("Invalid value for " & tItem4.DisplayFieldName, "", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Me.txtValue3.Focus()
                Exit Sub
            End If


            tItem4.Combiner = tC
            tItem4.Value1 = Me.txtValue4.Text
            blah.QItems.Add(tItem4)

        End If






        'Creating the Record set using the created sql string

        Cmd.CommandText = blah.SQLOut


        blah.LoadParameters(Cmd)


        DR = Cmd.ExecuteReader

        'Dim tFoundCollect = New Generic.List(Of Oligo)
        fCollect = New Collection

        If TypeOf Me.TheType Is Oligo Then
            Do While DR.Read
                fCollect.Add(New Oligo(DR))
            Loop
        ElseIf TypeOf Me.TheType Is Yeast Then
            Do While DR.Read
                fCollect.Add(New Yeast(DR))
            Loop
        ElseIf TypeOf Me.TheType Is Bacteria Then
            Do While DR.Read
                fCollect.Add(New Bacteria(DR))
            Loop

        ElseIf TypeOf Me.TheType Is CellLine Then
            Do While DR.Read
                fCollect.Add(New CellLine(DR))
            Loop

        Else
            Throw New Exception("type not supported")

        End If

        DR.Close()


        Me.DialogResult = Windows.Forms.DialogResult.OK

        '.paDialog(tCollect, GenDec.FormMode.ModeB)

    End Sub


    Private Sub txtValue1_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtValue1.KeyPress

        'This capture the enter key for triggering the search button click
        If Asc(e.KeyChar) = Keys.Enter Then

            btnSearch_Click(Nothing, Nothing)

        End If

    End Sub


#End Region


End Class