

''' <summary>
''' Is a listing form for displaying yeast database records.
''' </summary>
''' <remarks></remarks>
Public Class frmYeastList


    Public fYeastCollect As Collection 'holds
    Private fMode As GenDec.FormMode 'The forms mode, A=full list, B=search results


#Region " Form Events "


    Private Sub frmList_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'loading the form location data and listview column widths
        UFS.FormLoad(Me, GenDec.INIFileName, , 1)


        'loading the form up with data
        Me.FormLoad()

    End Sub

    Private Sub frmList_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        'saving the form settings like position and listview column widths
        UFS.FormSave(Me, GenDec.INIFileName, , 1)

    End Sub


#End Region


#Region " List View Support "


    Private Sub LVWLoadItem(ByRef rYeast As Yeast, Optional ByVal vIndex As Integer = -1, Optional ByVal vSelect As Byte = 0, Optional ByVal vRemItem As Byte = 0)

        Dim tItem As New ListViewItem 'preparing the new listview item

        tItem.Tag = rYeast

        'loading up the various columns of the listview item
        tItem.SubItems(0).Text = rYeast.FullName
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, String.Format(GenDec.cFormatDate, rYeast.RecDate)))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rYeast.FormerName))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rYeast.Donor))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rYeast.Plasmid))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rYeast.MatingType))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rYeast.Genotype))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rYeast.Comments))


        GenDec.LVWItemPlace(Me.lvwList, tItem, vIndex, vSelect, vRemItem)


    End Sub


    Private Sub lvwList_ColumnClick(ByVal sender As Object, ByVal e As System.Windows.Forms.ColumnClickEventArgs) Handles lvwList.ColumnClick

        Dim lvwColumnSorter As New LVWColSorter(Me.lvwList, e.Column)


        ' Set the column number that is to be sorted; default to ascending.
        If Me.lvwList.Sorting = SortOrder.Ascending Then
            'Was Ascending
            lvwColumnSorter.SortColumn = e.Column
            lvwColumnSorter.Order = SortOrder.Descending

            'Storing the sort order in the listview for later use
            Me.lvwList.Sorting = SortOrder.Descending

        Else
            'Was Descending
            lvwColumnSorter.SortColumn = e.Column
            lvwColumnSorter.Order = SortOrder.Ascending

            'Storing the sort order in the listview for later use
            Me.lvwList.Sorting = SortOrder.Ascending

        End If

        Me.lvwList.ListViewItemSorter = lvwColumnSorter

        ' Perform the sort with these new sort options.
        'Me.lvwList.Sort()


        If Me.lvwList.SelectedItems.Count > 0 Then
            Call Me.lvwList.SelectedItems(0).EnsureVisible()
        End If

    End Sub

    Private Sub lvwList_MouseDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles lvwList.MouseDoubleClick

        Call mnuEdit_Click(Nothing, Nothing)

    End Sub


#End Region


    ''' <summary>
    ''' Shows the Yeast form from a specified collection of yeast.
    ''' </summary>
    ''' <param name="rYeastCollect"></param>
    ''' <param name="vMode"></param>
    ''' <remarks></remarks>
    Public Sub paDialog(ByRef rYeastCollect As Collection, ByVal vMode As GenDec.FormMode)

        Me.fYeastCollect = rYeastCollect
        Me.fMode = vMode

        Me.Show()


    End Sub


#Region "Context Menu Support "


    Private Sub mnuEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuActionEdit.Click

        Me.mnuTSEdit_Click(Nothing, Nothing)

    End Sub


    Private Sub mnuPrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuActionPrint.Click
        'This is used to pring out a single yest database record.

        Dim PrintStr As String
        Dim tYeast As Yeast
        Dim tTextFile As IO.StreamWriter


        'Checking to make sure they have something selected
        If Me.lvwList.SelectedItems.Count = 0 Then Exit Sub


        'grabbing the yeast object out of the list view. This will be the same as one in the collection backend.
        tYeast = CType(Me.lvwList.SelectedItems(0).Tag, Yeast)


        With tYeast

            PrintStr = .FullName & vbCrLf & "RecDate: " & .RecDate & vbCrLf
            PrintStr = PrintStr & "Plasmid: " & .Plasmid & vbCrLf
            PrintStr = PrintStr & "Mating Type: " & .MatingType & vbCrLf
            PrintStr = PrintStr & "GenoType: " & .Genotype & vbCrLf
            PrintStr = PrintStr & "Former Name: " & .FormerName & vbCrLf
            PrintStr = PrintStr & "Donor: " & .Donor & vbCrLf
            PrintStr = PrintStr & "Comments: " & vbCrLf & .Comments & vbCrLf

            'Checking to make sure they have customized fields. If they do include them in the printout
            If .CustomField1 <> "" Then
                PrintStr = PrintStr & frmNewMain.YeastCustomField1 & ":" & .CustomField1 & vbCrLf
            End If

            If .CustomField2 <> "" Then
                PrintStr = PrintStr & frmNewMain.YeastCustomField2 & ":" & .CustomField2 & vbCrLf
            End If


        End With


        tTextFile = IO.File.CreateText(Application.StartupPath & "\Print.txt")

        tTextFile.Write(PrintStr)

        tTextFile.Close()

        'Opening up their text file.
        Process.Start(Application.StartupPath & "\Print.txt")


    End Sub

    Private Sub mnuActionFind_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuActionFind.Click

        Dim Blah As New frmLVWFind

        Blah.paShow(Me, Me.lvwList)


    End Sub


    Private Sub mnuActionAdd_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuActionAdd.Click

        Me.mnuTSAdd_Click(Nothing, Nothing)


    End Sub

    Private Sub mnuActionDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuActionDelete.Click

        Dim tYeast As Yeast

        If Me.lvwList.SelectedItems.Count = 0 Then Exit Sub

        tYeast = CType(Me.lvwList.SelectedItems(0).Tag, Yeast)

        If MessageBox.Show("Are you sure you want do delete " & tYeast.FullName & "?", My.Application.Info.ProductName, MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) = Windows.Forms.DialogResult.Yes Then
            Yeast.DBDelete(frmNewMain.Conn, tYeast.YeastID)
            Me.lvwList.SelectedItems(0).Remove()
        End If

    End Sub


#End Region


#Region " Main Menu Strip Support "


    Private Sub mnuTSFullList_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuTSFullList.Click
        'This is them flipping into the full list mode

        Me.fMode = GenDec.FormMode.ModeA 'setting the full list mode

        Me.FormLoad() 'reloading the form


    End Sub

    Private Sub mnuTSSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuTSSearch.Click

        Dim tSearchForm As New frmSearch
        Dim tYeast As New Yeast


        If tSearchForm.paDialog(tYeast, Me.fYeastCollect) = Windows.Forms.DialogResult.OK Then
            'They specified some search terms 

            Me.fMode = GenDec.FormMode.ModeB 'changing the mode

            Me.FormLoad() 'loading the form up again

        End If



    End Sub


    Private Sub mnuTSAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuTSAdd.Click


        Dim tYeastForm As New frmYeastMaint

        Dim tYeast As New Yeast

        If tYeastForm.paDialog(tYeast) = Windows.Forms.DialogResult.OK Then
            'They Clicked Ok

            Me.fMode = GenDec.FormMode.ModeA
            Me.FormLoad()

            tYeast.DBSave(frmNewMain.Conn)

            Me.LVWLoadItem(tYeast, , 1)

        End If

    End Sub

    Private Sub mnuTSEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuTSEdit.Click

        If Me.lvwList.SelectedItems.Count = 0 Then Exit Sub


        Dim Blah As New frmYeastMaint
        Dim tYeast As Yeast = CType(Me.lvwList.SelectedItems(0).Tag, Yeast)

        If Blah.paDialog(tYeast) = Windows.Forms.DialogResult.OK Then
            tYeast.DBSave(frmNewMain.Conn)

            'Updating the list with the new yeast
            Me.LVWLoadItem(tYeast, Me.lvwList.SelectedItems(0).Index, 1, 1)

        End If

    End Sub


    Private Sub mnuTSPrintList_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuTSPrintList.Click
        'This is way he wanted me to print to a text document the entire list. only includes a few fields.

        Dim tStr As String = ""
        Dim tTextFile As IO.StreamWriter = IO.File.CreateText(Application.StartupPath & "\Print.txt")


        'going through every yeast in the backend.
        For Each tYeast As Yeast In Me.fYeastCollect

            With tYeast
                tStr = tStr & .FullName & vbCrLf & String.Format(GenDec.cFormatDate, .RecDate) & vbCrLf & .FormerName & vbCrLf & .Donor & vbCrLf & vbCrLf
            End With


        Next

        tTextFile.Write(tStr)
        tTextFile.Close()


        'Loading up the textdocument
        Process.Start(Application.StartupPath & "\Print.txt")


    End Sub


#End Region


#Region " Form Support "

    ''' <summary>
    ''' Loads up the listview using data according to the form mode. FullList/Search Results.
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub FormLoad()

        Me.lvwList.Items.Clear() 'clearing the listview out


        Select Case fMode

            Case GenDec.FormMode.ModeA
                'Full List mode

                fYeastCollect.Clear() 'clearing out their collection of yeast from memory

                'retrieving all the yeasts from the database
                For Each tYeast As Yeast In Yeast.DBYeasts(frmNewMain.Conn)
                    fYeastCollect.Add(tYeast)
                Next

                'setting the forms text across the top
                Me.Text = "Yeast Complete List (" & fYeastCollect.Count & " Rows" & ")"


            Case GenDec.FormMode.ModeB
                'Search results mode

                'fYeastCollect will already be preloaded from the search page

                'setting the forms text across the top
                Me.Text = "Yeast Search Results (" & fYeastCollect.Count & " Rows" & ")"

            Case Else
                'unsupported mode
                Throw New Exception("No Mode for form")

        End Select

        'cyling through all the yeast objects and placing them in the listview
        For Each tyeast As Yeast In fYeastCollect
            Me.LVWLoadItem(tyeast)
        Next


    End Sub


#End Region

    
End Class
