''' <summary>
''' Form used for inserting, editing a yeast database frecord.
''' </summary>
''' <remarks></remarks>
Public Class frmYeastMaint


    Private TheYeast As Yeast 'Yeast object used
    Private fMode As GenDec.FormMode 'The mode the form is in


#Region " Form Events "

    Private Sub frmOligoMaint_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'UFS.FormLoad(Me, GenDec.INIFileName)


        If frmNewMain.YeastCustomField1 = "" Then
            Me.lblCustomField1.Text = "[Custom 1]:"
        Else
            Me.lblCustomField1.Text = frmNewMain.YeastCustomField1 & ":"
        End If

        If frmNewMain.YeastCustomField2 = "" Then
            Me.lblCustomField2.Text = "[Custom 2]:"
        Else
            Me.lblCustomField2.Text = frmNewMain.YeastCustomField2 & ":"
        End If



        If TheYeast.YeastID = 0 Then
            'New mode. It must be new because it has no yeastid like a valid database record would have
            Me.Text = "New Yeast"

            fMode = GenDec.FormMode.ModeAdd 'setting the mode

            TheYeast.LabName = frmNewMain.YeastLabSuffix 'setting the default suffix

            Me.txtSuffix.Text = Yeast.DBNextYeastID(frmNewMain.Conn)


        Else
            'Edit mode
            Me.Text = "Edit Yeast"
            fMode = GenDec.FormMode.ModeEdit
            Me.txtSuffix.Text = TheYeast.YeastID

        End If

        'setting the focus to the date because that is the first thing they are going to be modifying
        Me.dtpRecDate.Focus()

        'loading up the data
        Me.FormLoad()


    End Sub

    Private Sub frmOligoMaint_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        'UFS.FormSave(Me, GenDec.INIFileName)

    End Sub

#End Region


#Region " Form Support "

    Private Sub FormLoad()

        With Me.TheYeast

            Me.txtLabName.Text = .LabName
            Me.dtpRecDate.Value = .RecDate
            Me.txtPlasmid.Text = .Plasmid
            Me.txtMatingType.Text = .MatingType
            Me.txtDonor.Text = .Donor
            Me.txtFormerName.Text = .FormerName
            Me.txtComments.Text = .Comments
            Me.txtGenotype.Text = .Genotype
            Me.txtCustomField1.Text = .CustomField1
            Me.txtCustomField2.Text = .CustomField2

        End With


    End Sub

    Private Sub FormSave()

        With Me.TheYeast
            .LabName = Me.txtLabName.Text
            .RecDate = Me.dtpRecDate.Value
            .Plasmid = Me.txtPlasmid.Text
            .MatingType = Me.txtMatingType.Text
            .FormerName = Me.txtFormerName.Text
            .Donor = Me.txtDonor.Text
            .Comments = Me.txtComments.Text
            .Genotype = Me.txtGenotype.Text
            .CustomField1 = Me.txtCustomField1.Text
            .CustomField2 = Me.txtCustomField2.Text

        End With


    End Sub


#End Region


#Region " Validation Support "

    ''' <summary>
    ''' Validates the user yeast data
    ''' </summary>
    ''' <returns>True if all their data is valid</returns>
    ''' <remarks></remarks>
    Private Function ValidateForm() As Boolean

        'checking to make sure they have a lab name specified
        If Me.txtLabName.Text = "" Then
            MessageBox.Show("Specify Lab Name", My.Application.Info.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Information)
            Me.txtLabName.Focus()
            Exit Function
        End If

        'checking to make sure the have a formername specified
        If Me.txtFormerName.Text = "" Then
            MessageBox.Show("Specify Former Name", My.Application.Info.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Information)
            Me.txtLabName.Focus()
            Exit Function
        End If


        'Made it this far so it must all be valid data
        Return True

    End Function

#End Region


    ''' <summary>
    ''' 
    ''' </summary>
    ''' <param name="rYeast"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function paDialog(ByRef rYeast As Yeast) As Windows.Forms.DialogResult


        Me.TheYeast = rYeast

        Me.ShowDialog()

        Return Me.DialogResult


    End Function


#Region " Control Support "

    Private Sub btnOk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOk.Click

        If ValidateForm() = False Then Exit Sub

        'Saving the data
        Me.FormSave()

        'flagging that they clicked ok
        Me.DialogResult = Windows.Forms.DialogResult.OK

        Me.Close()


    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click

        Me.Close()

    End Sub


#End Region


End Class
